#include <Ice/Ice.h>
//#inclued <CCU_v1.h>
#include <CCU_v2.h>
#include <Command.h>
#include <State.h>
#include <Workqueue.h>

using namespace std;
using namespace CCU;

class CraneI : public Crane {
 public:
  CraneI(const WorkQueuePtr&);
  // set command
  virtual void setCommand_async(const CCU::AMD_Crane_setCommandPtr&, const ::std::string&,const ::CCU::LIST&, const ::Ice::Current&);
  // getCommandName
  virtual string getCommandName(const ::Ice::Current&);
  // getCommandParameters
  virtual LIST getCommandParameters(const ::Ice::Current&);
  // setCommandChanged
  virtual void setCommandChanged(const bool, const ::Ice::Current&);

  // set stateObjects
  virtual void setStateObjects(const ::CCU::LIST&, const ::Ice::Current&);
  // set statePropertiesPerObject
  virtual void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Current&);
  // set stateRelation
  virtual void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string& , const ::Ice::Current&);
  // get StateObjects
  virtual LIST getStateObjects(const ::Ice::Current&);
  // get StatePropertiesPerObject
  virtual LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Current&);
  // get RelationsFrom
  virtual LIST getRelationsFrom(const ::std::string&, const ::Ice::Current&);
  // getRelatedObjects
  virtual LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Current&);

  static Ice::CommunicatorPtr _communicator;
  static Ice::ObjectAdapterPtr _adapter;
 private:
  WorkQueuePtr _workQueue;
};

class Server : virtual public Ice::Application{
public:
  Server() {}
  int run(int argc,char* argv[]) {
		  shutdownOnInterrupt();
		  CraneI::_adapter = communicator()->createObjectAdapter("Crane");
		  _workQueue = new WorkQueue();
		  CraneI::_communicator = communicator();

		  Ice::ObjectPtr object = new CraneI(_workQueue);
		  CraneI::_adapter->add(object,communicator()->stringToIdentity("SimpleLogFile"));

		  _workQueue->start();
		  CraneI::_adapter->activate();

		  cout << "******************************************************" << endl;
		  cout << "*              shutting down with CTRL-C             *" << endl;
		  cout << "******************************************************" << endl;

		  communicator()->waitForShutdown();
		  if (interrupted()) {
			  _workQueue->destroy();
			  cout << "\n" << endl;
			  cout << "******************************************************" << endl;
			  cout << "*" << appName() << ": received signal, shutting down.*" << endl;
			  cout << "******************************************************" << endl;
		  }
		  _workQueue->getThreadControl().join();
		  return 0;
  }
  // Command
  static string _CommandName;
  static LIST _CommandParameters;
  static bool _commandChanged;
  // State
  static State _state;
  static bool _stateChanged;
private:
  WorkQueuePtr _workQueue;
};
