// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `CCU_v2.ice'

#include <CCU_v2.h>
#include <Ice/LocalException.h>
#include <Ice/ObjectFactory.h>
#include <Ice/BasicStream.h>
#include <IceUtil/Iterator.h>
#include <IceUtil/ScopedArray.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

static const ::std::string __CCU__Crane__setCommand_name = "setCommand";

static const ::std::string __CCU__Crane__getCommandParameters_name = "getCommandParameters";

static const ::std::string __CCU__Crane__getCommandName_name = "getCommandName";

static const ::std::string __CCU__Crane__setCommandChanged_name = "setCommandChanged";

static const ::std::string __CCU__Crane__setStateObjects_name = "setStateObjects";

static const ::std::string __CCU__Crane__setStatePropertiesPerObject_name = "setStatePropertiesPerObject";

static const ::std::string __CCU__Crane__setStateRelation_name = "setStateRelation";

static const ::std::string __CCU__Crane__getStateObjects_name = "getStateObjects";

static const ::std::string __CCU__Crane__getStatePropertiesPerObject_name = "getStatePropertiesPerObject";

static const ::std::string __CCU__Crane__getRelationsFrom_name = "getRelationsFrom";

static const ::std::string __CCU__Crane__getRelatedObjects_name = "getRelatedObjects";

::Ice::Object* IceInternal::upCast(::CCU::Crane* p) { return p; }
::IceProxy::Ice::Object* IceInternal::upCast(::IceProxy::CCU::Crane* p) { return p; }

void
CCU::__read(::IceInternal::BasicStream* __is, ::CCU::CranePrx& v)
{
    ::Ice::ObjectPrx proxy;
    __is->read(proxy);
    if(!proxy)
    {
        v = 0;
    }
    else
    {
        v = new ::IceProxy::CCU::Crane;
        v->__copyFrom(proxy);
    }
}

void
CCU::__writeLIST(::IceInternal::BasicStream* __os, const ::CCU::LIST& v)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(v.size());
    __os->writeSize(size);
    for(LIST::const_iterator p = v.begin(); p != v.end(); ++p)
    {
        __os->write((*p));
    }
}

void
CCU::__readLIST(::IceInternal::BasicStream* __is, ::CCU::LIST& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    LIST(sz).swap(v);
    __is->startSeq(sz, 1);
    for(LIST::iterator p = v.begin(); p != v.end(); ++p)
    {
        __is->read((*p));
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

void
CCU::__writeVECTOR(::IceInternal::BasicStream* __os, const ::CCU::VECTOR& v)
{
    ::Ice::Int size = static_cast< ::Ice::Int>(v.size());
    __os->writeSize(size);
    for(VECTOR::const_iterator p = v.begin(); p != v.end(); ++p)
    {
        __os->write((*p));
    }
}

void
CCU::__readVECTOR(::IceInternal::BasicStream* __is, ::CCU::VECTOR& v)
{
    ::Ice::Int sz;
    __is->readSize(sz);
    VECTOR(sz).swap(v);
    __is->startSeq(sz, 1);
    for(VECTOR::iterator p = v.begin(); p != v.end(); ++p)
    {
        __is->read((*p));
        __is->checkSeq();
        __is->endElement();
    }
    __is->endSeq(sz);
}

bool
CCU::AMI_Crane_setCommand::__invoke(const ::CCU::CranePrx& __prx, const ::std::string& name, const ::CCU::LIST& parameter, const ::Ice::Context* __ctx)
{
    __acquireCallback(__prx);
    try
    {
        __prepare(__prx, __CCU__Crane__setCommand_name, ::Ice::Normal, __ctx);
        __os->write(name);
        ::CCU::__writeLIST(__os, parameter);
        __os->endWriteEncaps();
        return __send();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __releaseCallback(__ex);
        return false;
    }
}

void
CCU::AMI_Crane_setCommand::__response(bool __ok)
{
    try
    {
        if(!__ok)
        {
            try
            {
                __throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                throw ::Ice::UnknownUserException(__FILE__, __LINE__, __ex.ice_name());
            }
            return;
        }
        __is->skipEmptyEncaps();
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __finished(__ex);
        return;
    }
    ice_response();
    __releaseCallback();
}

IceAsync::CCU::AMD_Crane_setCommand::AMD_Crane_setCommand(::IceInternal::Incoming& in) :
    ::IceInternal::IncomingAsync(in)
{
}

void
IceAsync::CCU::AMD_Crane_setCommand::ice_response()
{
    if(__validateResponse(true))
    {
        __response(true);
    }
}

void
IceAsync::CCU::AMD_Crane_setCommand::ice_exception(const ::std::exception& ex)
{
    if(__validateException(ex))
    {
        __exception(ex);
    }
}

void
IceAsync::CCU::AMD_Crane_setCommand::ice_exception()
{
    if(__validateException())
    {
        __exception();
    }
}

void
IceProxy::CCU::Crane::setCommand(const ::std::string& name, const ::CCU::LIST& parameter, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setCommand(name, parameter, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

bool
IceProxy::CCU::Crane::setCommand_async(const ::CCU::AMI_Crane_setCommandPtr& __cb, const ::std::string& name, const ::CCU::LIST& parameter)
{
    return __cb->__invoke(this, name, parameter, 0);
}

bool
IceProxy::CCU::Crane::setCommand_async(const ::CCU::AMI_Crane_setCommandPtr& __cb, const ::std::string& name, const ::CCU::LIST& parameter, const ::Ice::Context& __ctx)
{
    return __cb->__invoke(this, name, parameter, &__ctx);
}

::CCU::LIST
IceProxy::CCU::Crane::getCommandParameters(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getCommandParameters_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getCommandParameters(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::std::string
IceProxy::CCU::Crane::getCommandName(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getCommandName_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getCommandName(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::CCU::Crane::setCommandChanged(bool value, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setCommandChanged(value, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::CCU::Crane::setStateObjects(const ::CCU::LIST& objects, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setStateObjects(objects, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::CCU::Crane::setStatePropertiesPerObject(const ::std::string& obj, const ::CCU::LIST& properties, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setStatePropertiesPerObject(obj, properties, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

void
IceProxy::CCU::Crane::setStateRelation(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            __del->setStateRelation(relationFrom, relationTo, relation, __ctx);
            return;
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::CCU::LIST
IceProxy::CCU::Crane::getStateObjects(const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getStateObjects_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getStateObjects(__ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::CCU::LIST
IceProxy::CCU::Crane::getStatePropertiesPerObject(const ::std::string& obj, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getStatePropertiesPerObject_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getStatePropertiesPerObject(obj, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::CCU::LIST
IceProxy::CCU::Crane::getRelationsFrom(const ::std::string& obj, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getRelationsFrom_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getRelationsFrom(obj, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

::CCU::LIST
IceProxy::CCU::Crane::getRelatedObjects(const ::std::string& obj, const ::std::string& relation, const ::Ice::Context* __ctx)
{
    int __cnt = 0;
    while(true)
    {
        ::IceInternal::Handle< ::IceDelegate::Ice::Object> __delBase;
        try
        {
#if defined(__BCPLUSPLUS__) && (__BCPLUSPLUS__ >= 0x0600) // C++Builder 2009 compiler bug
            IceUtil::DummyBCC dummy;
#endif
            __checkTwowayOnly(__CCU__Crane__getRelatedObjects_name);
            __delBase = __getDelegate(false);
            ::IceDelegate::CCU::Crane* __del = dynamic_cast< ::IceDelegate::CCU::Crane*>(__delBase.get());
            return __del->getRelatedObjects(obj, relation, __ctx);
        }
        catch(const ::IceInternal::LocalExceptionWrapper& __ex)
        {
            __handleExceptionWrapper(__delBase, __ex, 0);
        }
        catch(const ::Ice::LocalException& __ex)
        {
            __handleException(__delBase, __ex, 0, __cnt);
        }
    }
}

const ::std::string&
IceProxy::CCU::Crane::ice_staticId()
{
    return ::CCU::Crane::ice_staticId();
}

::IceInternal::Handle< ::IceDelegateM::Ice::Object>
IceProxy::CCU::Crane::__createDelegateM()
{
    return ::IceInternal::Handle< ::IceDelegateM::Ice::Object>(new ::IceDelegateM::CCU::Crane);
}

::IceInternal::Handle< ::IceDelegateD::Ice::Object>
IceProxy::CCU::Crane::__createDelegateD()
{
    return ::IceInternal::Handle< ::IceDelegateD::Ice::Object>(new ::IceDelegateD::CCU::Crane);
}

::IceProxy::Ice::Object*
IceProxy::CCU::Crane::__newInstance() const
{
    return new Crane;
}

void
IceDelegateM::CCU::Crane::setCommand(const ::std::string& name, const ::CCU::LIST& parameter, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setCommand_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(name);
        ::CCU::__writeLIST(__os, parameter);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::CCU::LIST
IceDelegateM::CCU::Crane::getCommandParameters(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getCommandParameters_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::CCU::LIST __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::CCU::__readLIST(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::std::string
IceDelegateM::CCU::Crane::getCommandName(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getCommandName_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::std::string __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        __is->read(__ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateM::CCU::Crane::setCommandChanged(bool value, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setCommandChanged_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(value);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::CCU::Crane::setStateObjects(const ::CCU::LIST& objects, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setStateObjects_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        ::CCU::__writeLIST(__os, objects);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::CCU::Crane::setStatePropertiesPerObject(const ::std::string& obj, const ::CCU::LIST& properties, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setStatePropertiesPerObject_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(obj);
        ::CCU::__writeLIST(__os, properties);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

void
IceDelegateM::CCU::Crane::setStateRelation(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__setStateRelation_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(relationFrom);
        __os->write(relationTo);
        __os->write(relation);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    if(!__og.is()->b.empty())
    {
        try
        {
            if(!__ok)
            {
                try
                {
                    __og.throwUserException();
                }
                catch(const ::Ice::UserException& __ex)
                {
                    ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                    throw __uue;
                }
            }
            __og.is()->skipEmptyEncaps();
        }
        catch(const ::Ice::LocalException& __ex)
        {
            throw ::IceInternal::LocalExceptionWrapper(__ex, false);
        }
    }
}

::CCU::LIST
IceDelegateM::CCU::Crane::getStateObjects(const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getStateObjects_name, ::Ice::Normal, __context);
    bool __ok = __og.invoke();
    ::CCU::LIST __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::CCU::__readLIST(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::CCU::LIST
IceDelegateM::CCU::Crane::getStatePropertiesPerObject(const ::std::string& obj, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getStatePropertiesPerObject_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(obj);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::CCU::LIST __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::CCU::__readLIST(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::CCU::LIST
IceDelegateM::CCU::Crane::getRelationsFrom(const ::std::string& obj, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getRelationsFrom_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(obj);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::CCU::LIST __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::CCU::__readLIST(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

::CCU::LIST
IceDelegateM::CCU::Crane::getRelatedObjects(const ::std::string& obj, const ::std::string& relation, const ::Ice::Context* __context)
{
    ::IceInternal::Outgoing __og(__handler.get(), __CCU__Crane__getRelatedObjects_name, ::Ice::Normal, __context);
    try
    {
        ::IceInternal::BasicStream* __os = __og.os();
        __os->write(obj);
        __os->write(relation);
    }
    catch(const ::Ice::LocalException& __ex)
    {
        __og.abort(__ex);
    }
    bool __ok = __og.invoke();
    ::CCU::LIST __ret;
    try
    {
        if(!__ok)
        {
            try
            {
                __og.throwUserException();
            }
            catch(const ::Ice::UserException& __ex)
            {
                ::Ice::UnknownUserException __uue(__FILE__, __LINE__, __ex.ice_name());
                throw __uue;
            }
        }
        ::IceInternal::BasicStream* __is = __og.is();
        __is->startReadEncaps();
        ::CCU::__readLIST(__is, __ret);
        __is->endReadEncaps();
        return __ret;
    }
    catch(const ::Ice::LocalException& __ex)
    {
        throw ::IceInternal::LocalExceptionWrapper(__ex, false);
    }
}

void
IceDelegateD::CCU::Crane::setCommand(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*)
{
    throw ::Ice::CollocationOptimizationException(__FILE__, __LINE__);
}

::CCU::LIST
IceDelegateD::CCU::Crane::getCommandParameters(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::CCU::LIST& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getCommandParameters(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::CCU::LIST& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getCommandParameters_name, ::Ice::Normal, __context);
    ::CCU::LIST __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::std::string
IceDelegateD::CCU::Crane::getCommandName(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::std::string& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getCommandName(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::std::string& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getCommandName_name, ::Ice::Normal, __context);
    ::std::string __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

void
IceDelegateD::CCU::Crane::setCommandChanged(bool value, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(bool value, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_value(value)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setCommandChanged(_m_value, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        bool _m_value;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setCommandChanged_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(value, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::CCU::Crane::setStateObjects(const ::CCU::LIST& objects, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::CCU::LIST& objects, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_objects(objects)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setStateObjects(_m_objects, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::CCU::LIST& _m_objects;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setStateObjects_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(objects, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::CCU::Crane::setStatePropertiesPerObject(const ::std::string& obj, const ::CCU::LIST& properties, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& obj, const ::CCU::LIST& properties, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_obj(obj),
            _m_properties(properties)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setStatePropertiesPerObject(_m_obj, _m_properties, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_obj;
        const ::CCU::LIST& _m_properties;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setStatePropertiesPerObject_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(obj, properties, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

void
IceDelegateD::CCU::Crane::setStateRelation(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _m_relationFrom(relationFrom),
            _m_relationTo(relationTo),
            _m_relation(relation)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            servant->setStateRelation(_m_relationFrom, _m_relationTo, _m_relation, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        const ::std::string& _m_relationFrom;
        const ::std::string& _m_relationTo;
        const ::std::string& _m_relation;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__setStateRelation_name, ::Ice::Normal, __context);
    try
    {
        _DirectI __direct(relationFrom, relationTo, relation, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
}

::CCU::LIST
IceDelegateD::CCU::Crane::getStateObjects(const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::CCU::LIST& __result, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getStateObjects(_current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::CCU::LIST& _result;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getStateObjects_name, ::Ice::Normal, __context);
    ::CCU::LIST __result;
    try
    {
        _DirectI __direct(__result, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::CCU::LIST
IceDelegateD::CCU::Crane::getStatePropertiesPerObject(const ::std::string& obj, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::CCU::LIST& __result, const ::std::string& obj, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_obj(obj)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getStatePropertiesPerObject(_m_obj, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::CCU::LIST& _result;
        const ::std::string& _m_obj;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getStatePropertiesPerObject_name, ::Ice::Normal, __context);
    ::CCU::LIST __result;
    try
    {
        _DirectI __direct(__result, obj, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::CCU::LIST
IceDelegateD::CCU::Crane::getRelationsFrom(const ::std::string& obj, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::CCU::LIST& __result, const ::std::string& obj, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_obj(obj)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getRelationsFrom(_m_obj, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::CCU::LIST& _result;
        const ::std::string& _m_obj;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getRelationsFrom_name, ::Ice::Normal, __context);
    ::CCU::LIST __result;
    try
    {
        _DirectI __direct(__result, obj, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::CCU::LIST
IceDelegateD::CCU::Crane::getRelatedObjects(const ::std::string& obj, const ::std::string& relation, const ::Ice::Context* __context)
{
    class _DirectI : public ::IceInternal::Direct
    {
    public:

        _DirectI(::CCU::LIST& __result, const ::std::string& obj, const ::std::string& relation, const ::Ice::Current& __current) : 
            ::IceInternal::Direct(__current),
            _result(__result),
            _m_obj(obj),
            _m_relation(relation)
        {
        }
        
        virtual ::Ice::DispatchStatus
        run(::Ice::Object* object)
        {
            ::CCU::Crane* servant = dynamic_cast< ::CCU::Crane*>(object);
            if(!servant)
            {
                throw ::Ice::OperationNotExistException(__FILE__, __LINE__, _current.id, _current.facet, _current.operation);
            }
            _result = servant->getRelatedObjects(_m_obj, _m_relation, _current);
            return ::Ice::DispatchOK;
        }
        
    private:
        
        ::CCU::LIST& _result;
        const ::std::string& _m_obj;
        const ::std::string& _m_relation;
    };
    
    ::Ice::Current __current;
    __initCurrent(__current, __CCU__Crane__getRelatedObjects_name, ::Ice::Normal, __context);
    ::CCU::LIST __result;
    try
    {
        _DirectI __direct(__result, obj, relation, __current);
        try
        {
            __direct.servant()->__collocDispatch(__direct);
        }
        catch(...)
        {
            __direct.destroy();
            throw;
        }
        __direct.destroy();
    }
    catch(const ::Ice::SystemException&)
    {
        throw;
    }
    catch(const ::IceInternal::LocalExceptionWrapper&)
    {
        throw;
    }
    catch(const ::std::exception& __ex)
    {
        ::IceInternal::LocalExceptionWrapper::throwWrapper(__ex);
    }
    catch(...)
    {
        throw ::IceInternal::LocalExceptionWrapper(::Ice::UnknownException(__FILE__, __LINE__, "unknown c++ exception"), false);
    }
    return __result;
}

::Ice::ObjectPtr
CCU::Crane::ice_clone() const
{
    throw ::Ice::CloneNotImplementedException(__FILE__, __LINE__);
    return 0; // to avoid a warning with some compilers
}

static const ::std::string __CCU__Crane_ids[2] =
{
    "::CCU::Crane",
    "::Ice::Object"
};

bool
CCU::Crane::ice_isA(const ::std::string& _s, const ::Ice::Current&) const
{
    return ::std::binary_search(__CCU__Crane_ids, __CCU__Crane_ids + 2, _s);
}

::std::vector< ::std::string>
CCU::Crane::ice_ids(const ::Ice::Current&) const
{
    return ::std::vector< ::std::string>(&__CCU__Crane_ids[0], &__CCU__Crane_ids[2]);
}

const ::std::string&
CCU::Crane::ice_id(const ::Ice::Current&) const
{
    return __CCU__Crane_ids[0];
}

const ::std::string&
CCU::Crane::ice_staticId()
{
    return __CCU__Crane_ids[0];
}

::Ice::DispatchStatus
CCU::Crane::___setCommand(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string name;
    ::CCU::LIST parameter;
    __is->read(name);
    ::CCU::__readLIST(__is, parameter);
    __is->endReadEncaps();
    ::CCU::AMD_Crane_setCommandPtr __cb = new IceAsync::CCU::AMD_Crane_setCommand(__inS);
    try
    {
        setCommand_async(__cb, name, parameter, __current);
    }
    catch(const ::std::exception& __ex)
    {
        __cb->ice_exception(__ex);
    }
    catch(...)
    {
        __cb->ice_exception();
    }
    return ::Ice::DispatchAsync;
}

::Ice::DispatchStatus
CCU::Crane::___getCommandParameters(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::CCU::LIST __ret = getCommandParameters(__current);
    ::CCU::__writeLIST(__os, __ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___getCommandName(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::std::string __ret = getCommandName(__current);
    __os->write(__ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___setCommandChanged(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    bool value;
    __is->read(value);
    __is->endReadEncaps();
    setCommandChanged(value, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___setStateObjects(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::CCU::LIST objects;
    ::CCU::__readLIST(__is, objects);
    __is->endReadEncaps();
    setStateObjects(objects, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___setStatePropertiesPerObject(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string obj;
    ::CCU::LIST properties;
    __is->read(obj);
    ::CCU::__readLIST(__is, properties);
    __is->endReadEncaps();
    setStatePropertiesPerObject(obj, properties, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___setStateRelation(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string relationFrom;
    ::std::string relationTo;
    ::std::string relation;
    __is->read(relationFrom);
    __is->read(relationTo);
    __is->read(relation);
    __is->endReadEncaps();
    setStateRelation(relationFrom, relationTo, relation, __current);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___getStateObjects(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    __inS.is()->skipEmptyEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::CCU::LIST __ret = getStateObjects(__current);
    ::CCU::__writeLIST(__os, __ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___getStatePropertiesPerObject(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string obj;
    __is->read(obj);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::CCU::LIST __ret = getStatePropertiesPerObject(obj, __current);
    ::CCU::__writeLIST(__os, __ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___getRelationsFrom(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string obj;
    __is->read(obj);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::CCU::LIST __ret = getRelationsFrom(obj, __current);
    ::CCU::__writeLIST(__os, __ret);
    return ::Ice::DispatchOK;
}

::Ice::DispatchStatus
CCU::Crane::___getRelatedObjects(::IceInternal::Incoming& __inS, const ::Ice::Current& __current)
{
    __checkMode(::Ice::Normal, __current.mode);
    ::IceInternal::BasicStream* __is = __inS.is();
    __is->startReadEncaps();
    ::std::string obj;
    ::std::string relation;
    __is->read(obj);
    __is->read(relation);
    __is->endReadEncaps();
    ::IceInternal::BasicStream* __os = __inS.os();
    ::CCU::LIST __ret = getRelatedObjects(obj, relation, __current);
    ::CCU::__writeLIST(__os, __ret);
    return ::Ice::DispatchOK;
}

static ::std::string __CCU__Crane_all[] =
{
    "getCommandName",
    "getCommandParameters",
    "getRelatedObjects",
    "getRelationsFrom",
    "getStateObjects",
    "getStatePropertiesPerObject",
    "ice_id",
    "ice_ids",
    "ice_isA",
    "ice_ping",
    "setCommand",
    "setCommandChanged",
    "setStateObjects",
    "setStatePropertiesPerObject",
    "setStateRelation"
};

::Ice::DispatchStatus
CCU::Crane::__dispatch(::IceInternal::Incoming& in, const ::Ice::Current& current)
{
    ::std::pair< ::std::string*, ::std::string*> r = ::std::equal_range(__CCU__Crane_all, __CCU__Crane_all + 15, current.operation);
    if(r.first == r.second)
    {
        throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
    }

    switch(r.first - __CCU__Crane_all)
    {
        case 0:
        {
            return ___getCommandName(in, current);
        }
        case 1:
        {
            return ___getCommandParameters(in, current);
        }
        case 2:
        {
            return ___getRelatedObjects(in, current);
        }
        case 3:
        {
            return ___getRelationsFrom(in, current);
        }
        case 4:
        {
            return ___getStateObjects(in, current);
        }
        case 5:
        {
            return ___getStatePropertiesPerObject(in, current);
        }
        case 6:
        {
            return ___ice_id(in, current);
        }
        case 7:
        {
            return ___ice_ids(in, current);
        }
        case 8:
        {
            return ___ice_isA(in, current);
        }
        case 9:
        {
            return ___ice_ping(in, current);
        }
        case 10:
        {
            return ___setCommand(in, current);
        }
        case 11:
        {
            return ___setCommandChanged(in, current);
        }
        case 12:
        {
            return ___setStateObjects(in, current);
        }
        case 13:
        {
            return ___setStatePropertiesPerObject(in, current);
        }
        case 14:
        {
            return ___setStateRelation(in, current);
        }
    }

    assert(false);
    throw ::Ice::OperationNotExistException(__FILE__, __LINE__, current.id, current.facet, current.operation);
}

void
CCU::Crane::__write(::IceInternal::BasicStream* __os) const
{
    __os->writeTypeId(ice_staticId());
    __os->startWriteSlice();
    __os->endWriteSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__write(__os);
#else
    ::Ice::Object::__write(__os);
#endif
}

void
CCU::Crane::__read(::IceInternal::BasicStream* __is, bool __rid)
{
    if(__rid)
    {
        ::std::string myId;
        __is->readTypeId(myId);
    }
    __is->startReadSlice();
    __is->endReadSlice();
#if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
    Object::__read(__is, true);
#else
    ::Ice::Object::__read(__is, true);
#endif
}

void
CCU::Crane::__write(const ::Ice::OutputStreamPtr&) const
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Crane was not generated with stream support";
    throw ex;
}

void
CCU::Crane::__read(const ::Ice::InputStreamPtr&, bool)
{
    Ice::MarshalException ex(__FILE__, __LINE__);
    ex.reason = "type CCU::Crane was not generated with stream support";
    throw ex;
}

void 
CCU::__patch__CranePtr(void* __addr, ::Ice::ObjectPtr& v)
{
    ::CCU::CranePtr* p = static_cast< ::CCU::CranePtr*>(__addr);
    assert(p);
    *p = ::CCU::CranePtr::dynamicCast(v);
    if(v && !*p)
    {
        IceInternal::Ex::throwUOE(::CCU::Crane::ice_staticId(), v->ice_id());
    }
}

bool
CCU::operator==(const ::CCU::Crane& l, const ::CCU::Crane& r)
{
    return static_cast<const ::Ice::Object&>(l) == static_cast<const ::Ice::Object&>(r);
}

bool
CCU::operator<(const ::CCU::Crane& l, const ::CCU::Crane& r)
{
    return static_cast<const ::Ice::Object&>(l) < static_cast<const ::Ice::Object&>(r);
}
