/*
 * Command.cpp
 *
 *  Created on: 18.08.2009
 *      Author: ewert
 */

#include "Command.h"
#include <iostream>

namespace CCU
{

Command::Command()
{
	parameterIterator = parameters.begin();
}

Command::Command(std::string name)
{
	parameterIterator = parameters.begin();
	this->setName(name);

}

Command::~Command()
{
	// TODO Auto-generated destructor stub
}

std::string Command::getName() const
{
	return name;
}

void Command::addParam(std::string param)
{
	parameters.push_back(param);
	if (parameters.size() == 1)
		parameterIterator = parameters.begin();
}

void Command::setName(std::string name)
{
	this->name = name;
}

std::string Command::toString() const
{
	std::string tmp("Command: ");
	tmp += name;
	for (std::list<std::string>::const_iterator it = parameters.begin(); it
			!= parameters.end(); it++)
	{
		tmp += " " + *it;
	}
	return tmp;
}

std::list<std::string>::const_iterator Command::getParamEnd() const
{
	return parameters.end();
}

unsigned int Command::getNumberOfParams() const
{
	return parameters.size();
}

std::list<std::string>::const_iterator Command::getParamBegin() const
{
	return parameters.begin();
}

Command Command::operator= (const Command& newCommand)
{
	this->setName(newCommand.getName());

	std::list<std::string>::const_iterator ParamIt;

	// delete old parameters
	this->parameters.clear();

	std::list<std::string>::const_iterator it;

	for(ParamIt  = newCommand.getParamBegin();
		ParamIt != newCommand.getParamEnd();
		ParamIt++)
		this->addParam(*ParamIt);

	return *this;
};

}
