/*
 * Command.h
 *
 *  Created on: 18.08.2009
 *      Author: ewert
 */

#ifndef COMMAND_H_
#define COMMAND_H_

#include <string>
#include <list>

namespace CCU
{

class Command
{
public:
	Command();
	Command(std::string name);
	virtual ~Command();
	void setName(std::string name);
	std::string getName() const;
	void addParam(std::string param);
	std::list<std::string>::const_iterator getParamBegin() const;
	std::list<std::string>::const_iterator getParamEnd() const;
	unsigned int getNumberOfParams() const;
	std::string toString() const;

	// lenoch 21.09.09
	Command operator= (const Command&);

private:
	std::string name;
	std::list<std::string>::iterator parameterIterator;
	std::list<std::string> parameters;
};

}

#endif /* COMMAND_H_ */
