/*
 * Object.h
 *
 *  Created on: 21.07.2009
 *      Author: ewert
 *
 */

#ifndef OBJECT_H_
#define OBJECT_H_

#include <set>
#include <iostream>
#include <list>
#include <map>
#include <string>
#include <vector>

namespace CCU
{

class Object
{
private:
	std::string name;
	std::set<std::string> properties;
	std::vector<std::string> relations;
	std::vector<Object*> relatives;

public:
	Object();
	Object(const Object& copy);
	Object(std::string name);
	//Object(const Object* obj);

	/**
	 * Sets
	 */
	void setName(const std::string name);
	std::string getName() const;
	bool addProperty(std::string property);
	std::list<std::string> getProperties() const;
	bool addRelationTo(std::string name, Object* to);

	bool hasProperty(std::string property) const;
	bool hasRelation(std::string relation) const;

	std::list<std::string> getRelations() const;
	std::list<std::string> getRelatedObjects() const;
	std::list<std::string> getRelationsTo(Object* to) const;
	std::list<std::string> getRelatedToBy(std::string relation) const;

	void removeRelationsTo(const Object* obj);
	void removeProperty(const std::string prop);

	std::string toString() const;
	virtual ~Object();

	// lenoch 14.10
	bool removeRelation(const Object* obj, const std::string type);
};

}

#endif /* OBJECT_H_ */
