#ifndef WORK_QUEUE_H
#define WORK_QUEUE_H

#include <CCU_v2.h>
#include <IceUtil/IceUtil.h>

#include <list>

class WorkQueue : public IceUtil::Thread
{
public:

    WorkQueue();

    virtual void run();

    void add(const CCU::AMD_Crane_setCommandPtr&, const ::std::string&, const ::CCU::LIST&);
    void destroy();

private:

    struct setCommandCallbackEntry
    {
        CCU::AMD_Crane_setCommandPtr cb;
        std::string name;
        CCU::LIST parameter;
    };

    IceUtil::Monitor<IceUtil::Mutex> _monitor;
    std::list<setCommandCallbackEntry> _setcommandcallbacks;
    bool _setcommanddone;
};

typedef IceUtil::Handle<WorkQueue> WorkQueuePtr;

#endif
