// **********************************************************************
//
// Copyright (c) 2003-2009 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice version 3.3.1
// Generated from file `CCU_v2.ice'

#ifndef __CCU_v2_h__
#define __CCU_v2_h__

#include <Ice/LocalObjectF.h>
#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/Proxy.h>
#include <Ice/Object.h>
#include <Ice/Outgoing.h>
#include <Ice/OutgoingAsync.h>
#include <Ice/Incoming.h>
#include <Ice/IncomingAsync.h>
#include <Ice/Direct.h>
#include <Ice/StreamF.h>
#include <Ice/UndefSysMacros.h>
#include <list>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 303
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace IceProxy
{

namespace CCU
{

class Crane;

}

}

namespace CCU
{

class Crane;
bool operator==(const Crane&, const Crane&);
bool operator<(const Crane&, const Crane&);

}

namespace IceInternal
{

::Ice::Object* upCast(::CCU::Crane*);
::IceProxy::Ice::Object* upCast(::IceProxy::CCU::Crane*);

}

namespace CCU
{

typedef ::IceInternal::Handle< ::CCU::Crane> CranePtr;
typedef ::IceInternal::ProxyHandle< ::IceProxy::CCU::Crane> CranePrx;

void __read(::IceInternal::BasicStream*, CranePrx&);
void __patch__CranePtr(void*, ::Ice::ObjectPtr&);

}

namespace CCU
{

typedef std::list<std::string> LIST;
void __writeLIST(::IceInternal::BasicStream*, const LIST&);
void __readLIST(::IceInternal::BasicStream*, LIST&);

typedef std::vector<std::string> VECTOR;
void __writeVECTOR(::IceInternal::BasicStream*, const VECTOR&);
void __readVECTOR(::IceInternal::BasicStream*, VECTOR&);

}

namespace CCU
{

class AMI_Crane_setCommand : public ::IceInternal::OutgoingAsync
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::Ice::Exception&) = 0;

    bool __invoke(const ::CCU::CranePrx&, const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);

protected:

    virtual void __response(bool);
};

typedef ::IceUtil::Handle< ::CCU::AMI_Crane_setCommand> AMI_Crane_setCommandPtr;

class AMD_Crane_setCommand : virtual public ::IceUtil::Shared
{
public:

    virtual void ice_response() = 0;
    virtual void ice_exception(const ::std::exception&) = 0;
    virtual void ice_exception() = 0;
};

typedef ::IceUtil::Handle< ::CCU::AMD_Crane_setCommand> AMD_Crane_setCommandPtr;

}

namespace IceAsync
{

namespace CCU
{

class AMD_Crane_setCommand : public ::CCU::AMD_Crane_setCommand, public ::IceInternal::IncomingAsync
{
public:

    AMD_Crane_setCommand(::IceInternal::Incoming&);

    virtual void ice_response();
    virtual void ice_exception(const ::std::exception&);
    virtual void ice_exception();
};

}

}

namespace IceProxy
{

namespace CCU
{

class Crane : virtual public ::IceProxy::Ice::Object
{
public:

    void setCommand(const ::std::string& name, const ::CCU::LIST& parameter)
    {
        setCommand(name, parameter, 0);
    }
    void setCommand(const ::std::string& name, const ::CCU::LIST& parameter, const ::Ice::Context& __ctx)
    {
        setCommand(name, parameter, &__ctx);
    }
    
private:

    void setCommand(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);
    
public:
    bool setCommand_async(const ::CCU::AMI_Crane_setCommandPtr&, const ::std::string&, const ::CCU::LIST&);
    bool setCommand_async(const ::CCU::AMI_Crane_setCommandPtr&, const ::std::string&, const ::CCU::LIST&, const ::Ice::Context&);

    ::CCU::LIST getCommandParameters()
    {
        return getCommandParameters(0);
    }
    ::CCU::LIST getCommandParameters(const ::Ice::Context& __ctx)
    {
        return getCommandParameters(&__ctx);
    }
    
private:

    ::CCU::LIST getCommandParameters(const ::Ice::Context*);
    
public:

    ::std::string getCommandName()
    {
        return getCommandName(0);
    }
    ::std::string getCommandName(const ::Ice::Context& __ctx)
    {
        return getCommandName(&__ctx);
    }
    
private:

    ::std::string getCommandName(const ::Ice::Context*);
    
public:

    void setCommandChanged(bool value)
    {
        setCommandChanged(value, 0);
    }
    void setCommandChanged(bool value, const ::Ice::Context& __ctx)
    {
        setCommandChanged(value, &__ctx);
    }
    
private:

    void setCommandChanged(bool, const ::Ice::Context*);
    
public:

    void setStateObjects(const ::CCU::LIST& objects)
    {
        setStateObjects(objects, 0);
    }
    void setStateObjects(const ::CCU::LIST& objects, const ::Ice::Context& __ctx)
    {
        setStateObjects(objects, &__ctx);
    }
    
private:

    void setStateObjects(const ::CCU::LIST&, const ::Ice::Context*);
    
public:

    void setStatePropertiesPerObject(const ::std::string& obj, const ::CCU::LIST& properties)
    {
        setStatePropertiesPerObject(obj, properties, 0);
    }
    void setStatePropertiesPerObject(const ::std::string& obj, const ::CCU::LIST& properties, const ::Ice::Context& __ctx)
    {
        setStatePropertiesPerObject(obj, properties, &__ctx);
    }
    
private:

    void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);
    
public:

    void setStateRelation(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation)
    {
        setStateRelation(relationFrom, relationTo, relation, 0);
    }
    void setStateRelation(const ::std::string& relationFrom, const ::std::string& relationTo, const ::std::string& relation, const ::Ice::Context& __ctx)
    {
        setStateRelation(relationFrom, relationTo, relation, &__ctx);
    }
    
private:

    void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:

    ::CCU::LIST getStateObjects()
    {
        return getStateObjects(0);
    }
    ::CCU::LIST getStateObjects(const ::Ice::Context& __ctx)
    {
        return getStateObjects(&__ctx);
    }
    
private:

    ::CCU::LIST getStateObjects(const ::Ice::Context*);
    
public:

    ::CCU::LIST getStatePropertiesPerObject(const ::std::string& obj)
    {
        return getStatePropertiesPerObject(obj, 0);
    }
    ::CCU::LIST getStatePropertiesPerObject(const ::std::string& obj, const ::Ice::Context& __ctx)
    {
        return getStatePropertiesPerObject(obj, &__ctx);
    }
    
private:

    ::CCU::LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Context*);
    
public:

    ::CCU::LIST getRelationsFrom(const ::std::string& obj)
    {
        return getRelationsFrom(obj, 0);
    }
    ::CCU::LIST getRelationsFrom(const ::std::string& obj, const ::Ice::Context& __ctx)
    {
        return getRelationsFrom(obj, &__ctx);
    }
    
private:

    ::CCU::LIST getRelationsFrom(const ::std::string&, const ::Ice::Context*);
    
public:

    ::CCU::LIST getRelatedObjects(const ::std::string& obj, const ::std::string& relation)
    {
        return getRelatedObjects(obj, relation, 0);
    }
    ::CCU::LIST getRelatedObjects(const ::std::string& obj, const ::std::string& relation, const ::Ice::Context& __ctx)
    {
        return getRelatedObjects(obj, relation, &__ctx);
    }
    
private:

    ::CCU::LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Context*);
    
public:
    
    ::IceInternal::ProxyHandle<Crane> ice_context(const ::Ice::Context& __context) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_context(__context).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_context(__context).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_adapterId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_adapterId(__id).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_adapterId(__id).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_endpoints(const ::Ice::EndpointSeq& __endpoints) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_endpoints(__endpoints).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_endpoints(__endpoints).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_locatorCacheTimeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_locatorCacheTimeout(__timeout).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_locatorCacheTimeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_connectionCached(bool __cached) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_connectionCached(__cached).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_connectionCached(__cached).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_endpointSelection(::Ice::EndpointSelectionType __est) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_endpointSelection(__est).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_endpointSelection(__est).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_secure(bool __secure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_secure(__secure).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_secure(__secure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_preferSecure(bool __preferSecure) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_preferSecure(__preferSecure).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_preferSecure(__preferSecure).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_router(const ::Ice::RouterPrx& __router) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_router(__router).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_router(__router).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_locator(const ::Ice::LocatorPrx& __locator) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_locator(__locator).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_locator(__locator).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_collocationOptimized(bool __co) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_collocationOptimized(__co).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_collocationOptimized(__co).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_twoway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_twoway().get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_twoway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_oneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_oneway().get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_oneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_batchOneway() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_batchOneway().get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_batchOneway().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_datagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_datagram().get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_datagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_batchDatagram() const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_batchDatagram().get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_batchDatagram().get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_compress(bool __compress) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_compress(__compress).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_compress(__compress).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_timeout(int __timeout) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_timeout(__timeout).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_timeout(__timeout).get());
    #endif
    }
    
    ::IceInternal::ProxyHandle<Crane> ice_connectionId(const std::string& __id) const
    {
    #if defined(_MSC_VER) && (_MSC_VER < 1300) // VC++ 6 compiler bug
        typedef ::IceProxy::Ice::Object _Base;
        return dynamic_cast<Crane*>(_Base::ice_connectionId(__id).get());
    #else
        return dynamic_cast<Crane*>(::IceProxy::Ice::Object::ice_connectionId(__id).get());
    #endif
    }
    
    static const ::std::string& ice_staticId();

private: 

    virtual ::IceInternal::Handle< ::IceDelegateM::Ice::Object> __createDelegateM();
    virtual ::IceInternal::Handle< ::IceDelegateD::Ice::Object> __createDelegateD();
    virtual ::IceProxy::Ice::Object* __newInstance() const;
};

}

}

namespace IceDelegate
{

namespace CCU
{

class Crane : virtual public ::IceDelegate::Ice::Object
{
public:

    virtual void setCommand(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*) = 0;

    virtual ::CCU::LIST getCommandParameters(const ::Ice::Context*) = 0;

    virtual ::std::string getCommandName(const ::Ice::Context*) = 0;

    virtual void setCommandChanged(bool, const ::Ice::Context*) = 0;

    virtual void setStateObjects(const ::CCU::LIST&, const ::Ice::Context*) = 0;

    virtual void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*) = 0;

    virtual void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::CCU::LIST getStateObjects(const ::Ice::Context*) = 0;

    virtual ::CCU::LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::CCU::LIST getRelationsFrom(const ::std::string&, const ::Ice::Context*) = 0;

    virtual ::CCU::LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Context*) = 0;
};

}

}

namespace IceDelegateM
{

namespace CCU
{

class Crane : virtual public ::IceDelegate::CCU::Crane,
              virtual public ::IceDelegateM::Ice::Object
{
public:

    virtual void setCommand(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);

    virtual ::CCU::LIST getCommandParameters(const ::Ice::Context*);

    virtual ::std::string getCommandName(const ::Ice::Context*);

    virtual void setCommandChanged(bool, const ::Ice::Context*);

    virtual void setStateObjects(const ::CCU::LIST&, const ::Ice::Context*);

    virtual void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);

    virtual void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getStateObjects(const ::Ice::Context*);

    virtual ::CCU::LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getRelationsFrom(const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Context*);
};

}

}

namespace IceDelegateD
{

namespace CCU
{

class Crane : virtual public ::IceDelegate::CCU::Crane,
              virtual public ::IceDelegateD::Ice::Object
{
public:

    virtual void setCommand(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);

    virtual ::CCU::LIST getCommandParameters(const ::Ice::Context*);

    virtual ::std::string getCommandName(const ::Ice::Context*);

    virtual void setCommandChanged(bool, const ::Ice::Context*);

    virtual void setStateObjects(const ::CCU::LIST&, const ::Ice::Context*);

    virtual void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Context*);

    virtual void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getStateObjects(const ::Ice::Context*);

    virtual ::CCU::LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getRelationsFrom(const ::std::string&, const ::Ice::Context*);

    virtual ::CCU::LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Context*);
};

}

}

namespace CCU
{

class Crane : virtual public ::Ice::Object
{
public:

    typedef CranePrx ProxyType;
    typedef CranePtr PointerType;
    
    virtual ::Ice::ObjectPtr ice_clone() const;

    virtual bool ice_isA(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) const;
    virtual ::std::vector< ::std::string> ice_ids(const ::Ice::Current& = ::Ice::Current()) const;
    virtual const ::std::string& ice_id(const ::Ice::Current& = ::Ice::Current()) const;
    static const ::std::string& ice_staticId();

    virtual void setCommand_async(const ::CCU::AMD_Crane_setCommandPtr&, const ::std::string&, const ::CCU::LIST&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setCommand(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::CCU::LIST getCommandParameters(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getCommandParameters(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::std::string getCommandName(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getCommandName(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setCommandChanged(bool, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setCommandChanged(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setStateObjects(const ::CCU::LIST&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setStateObjects(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setStatePropertiesPerObject(const ::std::string&, const ::CCU::LIST&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setStatePropertiesPerObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void setStateRelation(const ::std::string&, const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___setStateRelation(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::CCU::LIST getStateObjects(const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getStateObjects(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::CCU::LIST getStatePropertiesPerObject(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getStatePropertiesPerObject(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::CCU::LIST getRelationsFrom(const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getRelationsFrom(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::CCU::LIST getRelatedObjects(const ::std::string&, const ::std::string&, const ::Ice::Current& = ::Ice::Current()) = 0;
    ::Ice::DispatchStatus ___getRelatedObjects(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual ::Ice::DispatchStatus __dispatch(::IceInternal::Incoming&, const ::Ice::Current&);

    virtual void __write(::IceInternal::BasicStream*) const;
    virtual void __read(::IceInternal::BasicStream*, bool);
    virtual void __write(const ::Ice::OutputStreamPtr&) const;
    virtual void __read(const ::Ice::InputStreamPtr&, bool);
};

}

#endif
